<template>
    <v-layout justify-center row wrap>
        <v-flex xs12 sm10 md8 lg6 class="elevation-4 pa-3 ma-1 white" shrink>
            <!--link to info page-->
            <p class="standardText">Õpilasesinduse liikmeid saate näha
                <router-link :to="{name: 'info'}">siit</router-link>
            </p>
            <p class="standardText">Õpilasesindusse on kandideerinud: </p>

            <v-data-table
                    :headers="headers"
                    :items="candidates"
            >
                <!-- show error when there is no candidates -->
                <template slot="no-data">
                    <v-progress-linear v-show="isLoading === true" :indeterminate="true"></v-progress-linear>
                    <v-alert :value="true" v-if="!isLoading" color="error" icon="warning">
                        Kandidaadid puuduvad :(
                    </v-alert>
                </template>
                <!--display candidates for everybody, deleting and accepting buttons in addition to admin-->
                <template slot="items" slot-scope="props">
                    <td class="standardText">{{ props.item.user.name }}</td>
                    <td class="standardText">{{ props.item.user.job_title }}</td>

                    <td>
                    <span v-if="user.role === 'admin' || props.item.user.id === user.id" class="mr-1">
                        <i @click="deleteCandidation(props.item.user.id)" class="material-icons red--text"
                           style="cursor: pointer;">delete</i>
                    </span>

                    <span v-if="user.role === 'admin'">
                        <i @click="accept(props.item.user.id)" class="material-icons green--text"
                           style="cursor: pointer;">add_circle</i>
                    </span>
                    </td>
                </template>
            </v-data-table>

            <!-- delete success alert -->
            <v-alert v-model="alerts.deleteSuccess" dismissible type="success">
                {{ this.deleteSuccess }}
            </v-alert>
            <!--accept success alert-->
            <v-alert v-model="alerts.acceptSuccess" dismissible type="success">
                {{ this.acceptSuccess }}
            </v-alert>
        </v-flex>
        <!--show candidating form only for users-->
        <v-flex class="elevation-4 pa-3 ma-1 white" xs12 sm10 md8 lg6 v-if="user.role === 'user'">
            <p class="text-xs-center blue--text standardText">Nimi
                <v-divider></v-divider>
            </p>
            <!--get logged in user info-->
            <p class="text-xs-center standardText">{{ this.user.name }}</p>
            <p class="text-xs-center blue--text standardText">E-mail
                <v-divider></v-divider>
            </p>
            <p class="text-xs-center standardText">{{ this.user.email }}</p>
            <p class="text-xs-center blue--text standardText">Õpitav eriala
                <v-divider></v-divider>
            </p>
            <p class="text-xs-center standardText">{{ this.user.job_title }}</p>

            <v-btn color="primary" class="mt-4" block @click="candidate">Kandideerin</v-btn>
            <!--candidation error alert-->
            <v-alert v-model="alerts.addError" dismissible type="error">
                {{ this.error }}
            </v-alert>
            <!--candidation success alert-->
            <v-alert v-model="alerts.addSuccess" dismissible type="success">
                {{ this.success }}
            </v-alert>
        </v-flex>
    </v-layout>
</template>

<script>
    import axios from "axios";
    import {mapGetters} from "vuex";

    export default {
        name: "Candidating",

        data() {
            return {
                dialog: false,
                headers: [
                    {text: 'Nimi', value: 'user.name'},
                    {text: 'Rühm', value: 'user.job_title'},
                    {text: '', value: 'delete or change Role'},
                ],
                candidates: [],
                error: null,
                success: null,
                deleteSuccess: null,
                acceptSuccess: null,
                isLoading: false,
                alerts: {
                    addSuccess: false,
                    addError: false,
                    deleteSuccess: false,
                    acceptSuccess: false
                }

            }
        },
        //Get all candidates
        //Define when to show loader
        created() {
            this.isLoading = true;
            axios.get('api/users/candidates').then(response => {
                this.isLoading = false;
                this.candidates = response.data;
            })
        },
        //Get logged in user info
        computed: {
            ...mapGetters([
                'user'
            ])
        },
        methods: {
            //delete candidation
            //send candidated user id to controller
            //show success alert
            //filter the candidate out of the table automatically
            deleteCandidation(userID) {
                axios.delete('api/candidates/' + userID).then(response => {
                    this.deleteSuccess = response.data.message;
                    this.alerts.deleteSuccess = true;
                    this.candidates = this.candidates.filter(item => item.user.id !== userID);
                })
            },
            //accept candidate
            //send candidates user id to controller
            //show success message
            //filter the candidate out of the table automatically
            accept(userID) {
                axios.post('/api/candidates/' + userID + '/accept').then(response => {
                    this.acceptSuccess = response.data.message;
                    this.alerts.acceptSuccess = true;
                    this.candidates = this.candidates.filter(item => item.user.id !== userID);
                })
            },
            //send candidate info to database
            //show success alert for success and error alert for error
            //put the candidate
            candidate() {
                axios.post('/api/candidates').then(response => {
                    this.success = response.data.message;
                    this.alerts.addSuccess = true;
                    this.candidates.push(response.data.candidate);
                }).catch(error => {
                    this.error = error.response.data.message;
                    this.alerts.addError = true;
                });
            }
        }
    }
</script>

<style scoped>
    .standardText {
        font-size: 16px;
    }
</style>
